#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX 10

char *gets_malloc();
void swap_ptr(char **p1, char **p2);
void print_strings(char **strings, int max);

int main()
{
	char *strings[MAX];
	int i, max, sorted;

	// init //

	for (i=0; i<MAX; i++)
	{
		printf("enter a string (%d): ", i);
		strings[i] = gets_malloc();
		// notice, it is illegal to use scanf("%d", strings[i]);
	}

	// printing //

	printf("\n\nUnsorted strings:\n");
	print_strings(strings, MAX);

	// sorting //

	for (sorted=0, max=MAX-1; !sorted && max>0; max--)
		for (sorted=1 ,i=0; i<max; i++)
			if (strcmp(strings[i], strings[i+1]) > 0)
			{
				swap_ptr(&strings[i], &strings[i+1]);
				sorted=0;
			}

	// printing //

	printf("\n\nSorted strings:\n");
	print_strings(strings, MAX);

	// cleanup //

	// the memory allocated needs to be freed when done !
	for (i=0; i<MAX; i++)
	{
		free(strings[i]);
		strings[i] = NULL;
	}

	return 0;
}

char *gets_malloc()
{
	char buffer[100];
	char *str=NULL;
	int len;

	scanf("%s", buffer);

	len = strlen(buffer);
	str = (char *) malloc(len + 1);

	strcpy(str, buffer);

	return str;
}

void swap_ptr(char **p1, char **p2)
{
	char *tmp;

	tmp = *p1;
	*p1 = *p2;
	*p2 = tmp;
}

void print_strings(char **strings, int max)
{
	int i;

	for (i=0; i<max; i++)
		printf("string (%d): %s\n", i, strings[i]);
}