#include <stdio.h>
#include <stdlib.h>

#define CHK_MEMORY_ALLOC(PTR)	if ( PTR == NULL ) \
								{ \
									printf("failed to allocate memory\n"); \
									exit(-1); \
								}


int main()
{
	int len;
	int *pArr;
	int **ppTree;

	int i, j;

	// input len, allocating memory accordingly to pArr and ppTree //

	printf("input len variable: ");
	scanf("%d", &len);
	
	pArr = (int *) malloc(len * sizeof(int));
	CHK_MEMORY_ALLOC(pArr)

	ppTree = (int **) malloc(len * sizeof(int *));
	CHK_MEMORY_ALLOC(ppTree)

	printf("\n");

	// input each element in pArr, allocating ppTree[X] elements accordingly //

	for (i=0; i<len; i++)
	{
		printf("input len of array (%d): ", i);
		scanf("%d", &pArr[i]);
	}

	printf("\n");

	for (i=0; i<len; i++)
	{
		// allocation of each element in ppTree[ i ]
		ppTree[i] = (int *) malloc(pArr[i] * sizeof(int));
		CHK_MEMORY_ALLOC(ppTree[i])
	}

	// initializing ppTree sub-elements to 1..N //

	for (i=0; i<len; i++)
		for (j=0; j<pArr[i]; j++)
			(ppTree[i])[j] = j+1;

	printf("\n\n");

	// printing len //

	printf("len = %d\n", len);
	
	printf("\n");

	// printing pArr //
	
	for (i=0; i<len; i++)
		printf("pArr[%d] = %d\n", i, pArr[i]);

	printf("\n\n");

	// printing ppTree //

	for (i=0; i<len; i++)
	{
		printf("ppTree[%d]: ", i);

		for (j=0; j<pArr[i]; j++)
			printf("%3d", (ppTree[i])[j]);

		printf("\n");
	}

	// freeing memory //

	for (i=0; i<len; i++)
		free(ppTree[i]);

	free (pArr);

	return 0;
}
